local function get_raw_userdata(ud)
    return tonumber("0x"..string.sub(tostring(ud), 11))
end

local status = 0
local offline = true
local enabled = false
local sharp = 1.0

re.on_draw_ui(function()
    local changed = false
	
    if imgui.tree_node("Sharpness Modifier") then
		if offline then
			changed, enabled = imgui.checkbox("Enabled", enabled)
			if enabled then
				changed, sharp = imgui.slider_float("Multiplier", sharp, 0.000001, 500.0)
			end
		else
			enabled = false
			imgui.text("Disabled for Online Play");
		end
        imgui.tree_pop()
		imgui.text(' - made by Fylex');
    end
end)

local function on_pre_get_sharpness_adjust_rate(args)
    local sharpness = args[2]
    local sharpness_category = args[3]

    log.debug("Sharpness: " .. tostring(sharpness))
    log.debug("Sharpness category: " .. tostring(sharpness_category))
end

local function on_post_get_sharpness_adjust_rate(retval)
	if enabled then
		if offline then
			return sdk.float_to_ptr(sharp)
		else
			return sdk.float_to_ptr(1.0)
		end
	else
		return sdk.float_to_ptr(1.0)
	end
end

local function on_pre_is_online(args)
	--do nothing
end

local function on_post_is_online(retval)
	status = get_raw_userdata(retval)
	if status > 0 then
		offline = false
	else
		offline = true
	end
	return retval
end

sdk.hook(
    sdk.find_type_definition("snow.player.PlayerSharpnessAdjustRate"):get_method("getSharpnessAdjustRate"), 
    on_pre_get_sharpness_adjust_rate, 
    on_post_get_sharpness_adjust_rate)

sdk.hook(
	sdk.find_type_definition("snow.LobbyManager"):get_method("isOnline"),
	on_pre_is_online,
	on_post_is_online)